package com.red.circle.other.app.inner.endpoint.sys;

import com.red.circle.framework.dto.PageResult;
import com.red.circle.framework.dto.ResultResponse;
import com.red.circle.other.app.inner.service.sys.SysMikeTypeConfigClientService;
import com.red.circle.other.inner.endpoint.sys.api.SysMikeTypeConfigClientApi;
import com.red.circle.other.inner.model.cmd.sys.SysMikeTypeConfigQryCmd;
import com.red.circle.other.inner.model.dto.sys.SysMikeTypeConfigDTO;
import lombok.RequiredArgsConstructor;
import org.springframework.http.MediaType;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author zongpubin on 2023/10/30
 */
@Validated
@RestController
@RequestMapping(value = SysMikeTypeConfigClientApi.API_PREFIX, produces = MediaType.APPLICATION_JSON_VALUE)
@RequiredArgsConstructor
public class SysMikeTypeConfigClientEndpoint implements SysMikeTypeConfigClientApi {

  private final SysMikeTypeConfigClientService mikeTypeConfigClientService;

  @Override
  public ResultResponse<PageResult<SysMikeTypeConfigDTO>> getMikeType(
      SysMikeTypeConfigQryCmd query) {
    return ResultResponse.success(mikeTypeConfigClientService.getMikeType(query));
  }

  @Override
  public ResultResponse<Void> addMikeType(SysMikeTypeConfigDTO mikeTypeConfigDTO) {
    mikeTypeConfigClientService.addMikeType(mikeTypeConfigDTO);
    return ResultResponse.success();
  }

  @Override
  public ResultResponse<Void> removeMikeType(Long id) {
    mikeTypeConfigClientService.removeMikeType(id);
    return ResultResponse.success();
  }

  @Override
  public ResultResponse<Void> updateMikeType(SysMikeTypeConfigDTO mikeTypeConfigDTO) {
    mikeTypeConfigClientService.updateMikeType(mikeTypeConfigDTO);
    return ResultResponse.success();
  }
}
